/* NetRun C++ Wrapper (Public Domain) */
#include <cstdio>
#include <cstdlib>
#include <ctype.h>
#include <cstring>
#include <cmath>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <vector>
#include <map>
#include <string>
#include "osl/socket.h"
#include "osl/socket.cpp"

int main(void) {
	skt_ip_t ip=skt_lookup_ip("137.229.25.247"); // lawlor.cs.uaf.edu
	SOCKET s=skt_connect(ip,80,2);

/* Send off HTTP request to server (with URL) */
	const char *req=
		"GET /index.html HTTP/1.1\r\n"  // the "/" is the URL I'm requesting
		"Host: lawlor.cs.uaf.edu\r\n" // hostname is required for HTTP 1.1
		"User-Agent: Raw socket example code (lawlor@alaska.edu)\r\n" // web browser ID string
		"\r\n"; // blank line == end of HTTP request
	skt_sendN(s,req,strlen(req));

/* Receive HTTP response headers, up to the newline */
	std::string response;
	int length=0;
	while ((response=skt_recv_line(s))!="")
	{
		std::cout<<response<<"\n";
		const char *start="Content-Length:";
		if (response.substr(0,strlen(start))==start) length=atoi(response.substr(strlen(start)+1).c_str());
	}
	std::cout<<"Waiting for "<<length<<" bytes of binary data\n";
	
	std::vector<char> data(length);
	skt_recvN(s,&data[0],length);

	std::cout<<"Binary data at'cha!\n"<<&data[0]<<"\n";

	skt_close(s);
	return 0;
}




